"use strict";
exports.__esModule = true;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
function useSafeAsyncMount(effect, cleanup) {
    var isMounted = (0, react_1.useRef)(false);
    var _a = (0, react_1.useState)(function () { return function () { return (0, jsx_runtime_1.jsx)(react_1.Fragment, {}); }; }), SafeRender = _a[0], setSafeRender = _a[1];
    var _b = (0, react_1.useState)(), safeState = _b[0], setSafeState = _b[1];
    var hasCleanup = typeof cleanup === 'function';
    (0, react_1.useEffect)(function () {
        var result;
        isMounted.current = true;
        var maybePromise = effect(function () { return isMounted.current; });
        Promise.resolve(maybePromise).then(function (value) {
            result = value;
            if (isMounted.current) {
                setSafeState(result);
            }
        });
        return function () {
            isMounted.current = false;
            if (hasCleanup) {
                cleanup(result);
            }
        };
    }, []);
    (0, react_1.useEffect)(function () {
        if (safeState) {
            setSafeRender(function () { return function (props) { return ((0, jsx_runtime_1.jsx)(react_1.Fragment, { children: typeof props.children !== 'function' ? props.children : props.children(safeState) })); }; });
        }
    }, [safeState]);
    return {
        isMounted: isMounted.current,
        SafeRender: SafeRender,
        safeState: safeState
    };
}
exports["default"] = useSafeAsyncMount;
//# sourceMappingURL=index.js.map